题目:给定一个整数数组和一个目标值,找出数组中和为目标值的两个数。
你可以假设每个输入只对应一种答案,且同样的元素不能被重复利用。
示例:
给定 nums = [2, 7, 11, 15], target = 9 因为 nums[0] + nums[1] = 2 + 7 = 9 所以返回 [0, 1]
思路:最容易想到的方法是暴力枚举,列举出所有的可能,然后记录两个数之和等于target的的下标返回即可,但是这种方法时间复杂度为O(n²)。因为要记录下标,所以先排序也是不好的。之后想到了hashmap,用hashmap的key-value分别记录每个数和对应的下标,然后只需遍历一次,假设当前遍历的数记为tmp,看看hashmap中是否存在target-tmp的数,且此数的下标不等于tmp的下标,分别记录返回即可。时间复杂度O(n),空间复杂度O(n)。
举例说明:数组[3,2,7,4,6] target = 6
1)hashmap存储:<3,0> <2,1> <7,2> <4,3> <6,4>
2)遍历数组 设当前数为tmp,tmp = 3时,看看hashmap中是否存在6-3=3的key,不存在,tmp继续往下遍历
tmp=2,看看hashmap中是否存在6-2 = 4的key,存在,记录2的下标1,并取出4对应的value:3,返回[1.3]为结果。
代码如下:
import java.*;
class Solution {
public int[] twoSum(int[] nums, int target) {
int[] res = new int[2];
Map<Integer, Integer> map = new HashMap<Integer, Integer>();
for (int i = 0; i < nums.length; ++i) {
map.put(nums[i], i);
}
for (int i = 0; i < nums.length; i++) {
int tmp = target - nums[i];
if (map.containsKey(tmp) && map.get(tmp) != i) {
res[0] = i;
res[1] = map.get(tmp);
}
}
return res;
}
}